/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.75 Revision 1.118
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.75 2010/07/03 09:10:55 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.118 2012/02/09 22:58:36 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
17MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
21IUSE="aqua debug pch"
22
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21else 24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 MY_P=qt-x11-opensource-src-${MY_PV} 25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
23fi 29fi
24 30
25HOMEPAGE="http://qt.nokia.com/" 31DEPEND="dev-util/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND=" 32RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 45 !<x11-libs/qt-multimedia-${PV}
63 66
64S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
65 68
66# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 70# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 74
72 # Protect users by not allowing downgrades between releases 75 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 76 # Downgrading revisions within the same release should be allowed
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 77 if has_version '>'${CATEGORY}/${P}-r9999; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 79 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 80 eerror " Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 81 die "aborting to save your system"
79 else 82 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 84 fi
82 fi 85 fi
83 86
84 if [[ "${PN}" == "qt-webkit" ]]; then 87 if [[ ${PN} == "qt-webkit" ]]; then
85 eshopts_push -s extglob 88 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then 89 if is-flagq '-g?(gdb)?([1-9])'; then
87 echo 90 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage." 92 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug." 93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861" 94 ewarn "For more info check out bug #307861"
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 110 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 111 fi
109 112
110 # Make sure ebuilds use the required EAPI 113 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then 114 if [[ ${EAPI} != [234] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 115 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be" 116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail." 117 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3" 118 die "qt4-build eclass requires EAPI 2,3 or 4"
116 fi 119 fi
117 120
118 if ! version_is_at_least 4.1 $(gcc-version); then 121 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi 123 fi
121} 124}
122 125
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
124# @DESCRIPTION: 127# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
127 130
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION: 132# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
131# tarball 134# Qt tarball.
132 135
133# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 137# @DESCRIPTION:
135# Unpacks the sources 138# Unpacks the sources.
136qt4-build_src_unpack() { 139qt4-build_src_unpack() {
137 setqtenv 140 setqtenv
138 local target targets= 141
142 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
142 targets+=" ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
143 done 148 done
144 149
150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 152 eend $? || die "failed to unpack"
147} 153}
148 154
149# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
150# @DESCRIPTION: 157# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
153# example: 160# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
155# ${FILESDIR}"/mypatch2.patch"
156# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
157 167
158# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 169# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
162qt4-build_src_prepare() { 172qt4-build_src_prepare() {
163 setqtenv 173 setqtenv
164 cd "${S}" 174 cd "${S}"
165 175
166 # fix qt 4.7 regression that skips -fvisibility=hidden
167 if version_is_at_least "4.7.0_beta1"; then 176 if version_is_at_least "4.7"; then
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 177 # fix libX11 dependency on non X packages
169 -i config.tests/unix/fvisibility.test || 178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
170 die "visibility fixing sed failed" 179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
171 fi 182 fi
172 183
173 if use aqua; then 184 if use aqua; then
174 # provide a proper macx-g++-64 185 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 187
177 sed -e '/^CONFIG/s:app_bundle::' \ 188 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 191 fi
181 192
182 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
183 skip_qmake_build_patch 194 skip_qmake_build
184 skip_project_generation_patch 195 skip_project_generation
185 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
186 fi 197 fi
187 198
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
189 # qmake bus errors with -O2 but -O3 works 200 # qmake bus errors with -O2 but -O3 works
192 203
193 # Bug 178652 204 # Bug 178652
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse 207 append-flags -fno-gcse
208 fi
209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
197 fi 217 fi
198 218
199 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
203 # Bug 253127 223 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
206 fi 226 fi
207 227
208 # Bug 261632 228 # Bug 261632
209 if use ppc64; then 229 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 231 append-flags -mminimal-toc
212 fi 232 fi
213 233
214 # Bug 282984 && Bug 295530 234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 235 sed -e "/^SYSTEM_VARIABLES=/i \
216 -i configure || die "sed qmake compilers failed" 236 CC='$(tc-getCC)'\n\
217 # bug 321335 237 CXX='$(tc-getCXX)'\n\
218 if version_is_at_least 4.6; then 238 CFLAGS='${CFLAGS}'\n\
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 239 CXXFLAGS='${CXXFLAGS}'\n\
220 xargs -0 \ 240 LDFLAGS='${LDFLAGS}'\n" \
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \ 241 -i configure \
222 -i || die "sed test compilers failed" 242 || die "sed SYSTEM_VARIABLES failed"
223 fi 243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
224 253
225 # Bug 172219 254 # Bug 172219
226 sed -e "s:X11R6/::" \ 255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 256
229 if [[ ${CHOST} == *-darwin* ]]; then 257 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 259 # crippled (by design) :/
260 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 264 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
237 267
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 269 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 270 # pch). Additionally disable Xarch support.
241 sed \ 271 sed \
246 -e "s:-arch \$i::" \ 276 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 279 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 280 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
252 283
253 # On Snow Leopard don't fall back to 10.5 deployment target. 284 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
258 fi 290 fi
259 fi 291 fi
260 292
261 # this one is needed for all systems with a separate -liconv, apart from 293 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 294 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
264 sed \ 296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 297 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 298 || die "sed iconv.pro failed"
268 fi 299 fi
269 300
270 # we need some patches for Solaris 301 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 304 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 306 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 # strip predefined CFLAGS from qmake ( bug #312689 )
280 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
281 309
282 base_src_prepare 310 base_src_prepare
283} 311}
284 312
285# @FUNCTION: qt4-build_src_configure 313# @FUNCTION: qt4-build_src_configure
292 # this one is needed for all systems with a separate -liconv, apart from 320 # this one is needed for all systems with a separate -liconv, apart from
293 # Darwin, for which the sources already cater for -liconv 321 # Darwin, for which the sources already cater for -liconv
294 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
295 myconf+=" -liconv" 323 myconf+=" -liconv"
296 324
297 if has glib ${IUSE//+} && use glib; then 325 if use_if_iuse glib; then
298 # use -I, -L and -l from configure 326 # use -I, -L and -l from configure
299 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
300 # avoid the -pthread argument 328 # avoid the -pthread argument
301 myconf+=" ${glibflags//-pthread}" 329 myconf+=" ${glibflags//-pthread}"
302 unset glibflags 330 unset glibflags
303 fi 331 fi
304 332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
305 if use aqua ; then 342 if use aqua ; then
306 # On (snow) leopard use the new (frameworked) cocoa code. 343 # On (snow) leopard use the new (frameworked) cocoa code.
307 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
308 myconf+=" -cocoa -framework" 345 myconf+=" -cocoa -framework"
309 346
310 # We are crazy and build cocoa + qt3support :-) 347 # We are crazy and build cocoa + qt3support :-)
311 if use qt3support; then 348 if use qt3support; then
312 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
313 -i configure 350 -i configure || die
314 fi 351 fi
315 352
316 # We need the source's headers, not the installed ones. 353 # We need the source's headers, not the installed ones.
317 myconf+=" -I${S}/include" 354 myconf+=" -I${S}/include"
318 355
326 fi 363 fi
327 364
328 echo ./configure ${myconf} 365 echo ./configure ${myconf}
329 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
330 myconf="" 367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
331} 370}
332 371
333# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
334# @DESCRIPTION: Actual compile phase 374# Actual compile phase
335qt4-build_src_compile() { 375qt4-build_src_compile() {
336 setqtenv 376 setqtenv
337 377
338 build_directories ${QT4_TARGET_DIRECTORIES} 378 build_directories ${QT4_TARGET_DIRECTORIES}
339} 379}
340 380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 # QtMultimedia does not have any test suite (bug #332299)
386 [[ ${PN} == "qt-multimedia" ]] && return
387
388 for dir in ${QT4_TARGET_DIRECTORIES}; do
389 emake -j1 check -C ${dir}
390 done
391}
392
341# @FUNCTION: fix_includes 393# @FUNCTION: fix_includes
342# @DESCRIPTION: 394# @DESCRIPTION:
343# For MacOSX we need to add some symlinks when frameworks are 395# For MacOS X we need to add some symlinks when frameworks are
344# being used, to avoid complications with some more or less stupid packages. 396# being used, to avoid complications with some more or less stupid packages.
345fix_includes() { 397fix_includes() {
346 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 398 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
347 # Some packages tend to include <Qt/...> 399 # Some packages tend to include <Qt/...>
348 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 400 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
349 401
350 # Fake normal headers when frameworks are installed... eases life later on 402 # Fake normal headers when frameworks are installed... eases life later on
351 local dest f 403 local dest f h
352 for frw in "${D}${QTLIBDIR}"/*.framework; do 404 for frw in "${D}${QTLIBDIR}"/*.framework; do
353 [[ -e "${frw}"/Headers ]] || continue 405 [[ -e "${frw}"/Headers ]] || continue
354 f=$(basename ${frw}) 406 f=$(basename ${frw})
355 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 407 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
356 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 408 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
368# @DESCRIPTION: 420# @DESCRIPTION:
369# Perform the actual installation including some library fixes. 421# Perform the actual installation including some library fixes.
370qt4-build_src_install() { 422qt4-build_src_install() {
371 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 423 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
372 setqtenv 424 setqtenv
425
373 install_directories ${QT4_TARGET_DIRECTORIES} 426 install_directories ${QT4_TARGET_DIRECTORIES}
374 install_qconfigs 427 install_qconfigs
375 fix_library_files 428 fix_library_files
376 fix_includes 429 fix_includes
430
431 # remove .la files since we are building only shared Qt libraries
432 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
377} 433}
378 434
379# @FUNCTION: setqtenv 435# @FUNCTION: setqtenv
436# @INTERNAL
380setqtenv() { 437setqtenv() {
381 # Set up installation directories 438 # Set up installation directories
382 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
383 QTPREFIXDIR=${EPREFIX}/usr 439 QTPREFIXDIR=${EPREFIX}/usr
384 QTBINDIR=${EPREFIX}/usr/bin 440 QTBINDIR=${EPREFIX}/usr/bin
385 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 441 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
386 QMAKE_LIBDIR_QT=${QTLIBDIR}
387 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 442 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
388 QTDATADIR=${EPREFIX}/usr/share/qt4
389 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 443 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
390 QTHEADERDIR=${EPREFIX}/usr/include/qt4 444 QTHEADERDIR=${EPREFIX}/usr/include/qt4
391 QTPLUGINDIR=${QTLIBDIR}/plugins 445 QTPLUGINDIR=${QTLIBDIR}/plugins
446 QTIMPORTDIR=${QTLIBDIR}/imports
447 QTDATADIR=${EPREFIX}/usr/share/qt4
448 QTTRANSDIR=${QTDATADIR}/translations
392 QTSYSCONFDIR=${EPREFIX}/etc/qt4 449 QTSYSCONFDIR=${EPREFIX}/etc/qt4
393 QTTRANSDIR=${QTDATADIR}/translations
394 QTEXAMPLESDIR=${QTDATADIR}/examples 450 QTEXAMPLESDIR=${QTDATADIR}/examples
395 QTDEMOSDIR=${QTDATADIR}/demos 451 QTDEMOSDIR=${QTDATADIR}/demos
452 QMAKE_LIBDIR_QT=${QTLIBDIR}
396 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 453 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
454
397 PLATFORM=$(qt_mkspecs_dir) 455 PLATFORM=$(qt_mkspecs_dir)
398 456
399 unset QMAKESPEC 457 unset QMAKESPEC
400} 458}
401 459
402# @FUNCTION: standard_configure_options 460# @FUNCTION: standard_configure_options
461# @INTERNAL
403# @DESCRIPTION: 462# @DESCRIPTION:
404# Sets up some standard configure options, like libdir (if necessary), whether 463# Sets up some standard configure options, like libdir (if necessary), whether
405# debug info is wanted or not. 464# debug info is wanted or not.
406standard_configure_options() { 465standard_configure_options() {
407 local myconf= 466 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
467 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
468 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
469 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
470 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
471 -opensource -confirm-license -shared -fast -largefile -stl -verbose
472 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
408 473
409 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 474 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
410 475
411 # Disable visibility explicitly if gcc version isn't 4 476 # debug/release
412 if [[ $(gcc-major-version) -lt 4 ]]; then
413 myconf+=" -no-reduce-exports"
414 fi
415
416 # precompiled headers doesn't work on hardened, where the flag is masked.
417 myconf+=" $(qt_use pch)"
418
419 if use debug; then 477 if use debug; then
420 myconf+=" -debug" 478 myconf+=" -debug"
421 else 479 else
422 myconf+=" -release" 480 myconf+=" -release"
423 fi 481 fi
424 myconf+=" -no-separate-debug-info" 482 myconf+=" -no-separate-debug-info"
425 483
484 # exceptions USE flag
485 local exceptions="-exceptions"
486 in_iuse exceptions && exceptions="$(qt_use exceptions)"
487 myconf+=" ${exceptions}"
488
489 # disable RPATH on Qt >= 4.8 (bug 380415)
490 version_is_at_least 4.8 && myconf+=" -no-rpath"
491
492 # precompiled headers don't work on hardened, where the flag is masked
493 myconf+=" $(qt_use pch)"
494
495 # -reduce-relocations
496 # This flag seems to introduce major breakage to applications,
497 # mostly to be seen as a core dump with the message "QPixmap: Must
498 # construct a QApplication before a QPaintDevice" on Solaris.
499 # -- Daniel Vergien
500 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
501
426 use aqua && myconf+=" -no-framework" 502 use aqua && myconf+=" -no-framework"
427 503
428 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 504 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
429 # $(tc-arch). Therefore we convert it to supported values. 505 # $(tc-arch). Therefore we convert it to supported values.
430 case "$(tc-arch)" in 506 case "$(tc-arch)" in
431 amd64|x64-*) myconf+=" -arch x86_64" ;; 507 amd64|x64-*) myconf+=" -arch x86_64" ;;
432 ppc-macos) myconf+=" -arch ppc" ;; 508 ppc-macos) myconf+=" -arch ppc" ;;
433 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;; 509 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
434 sparc|sparc-*) myconf+=" -arch sparc" ;; 510 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
435 x86-macos) myconf+=" -arch x86" ;; 511 x86-macos) myconf+=" -arch x86" ;;
436 x86|x86-*) myconf+=" -arch i386" ;; 512 x86|x86-*) myconf+=" -arch i386" ;;
437 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;; 513 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
438 hppa|sh) myconf+=" -arch generic" ;; 514 hppa|sh) myconf+=" -arch generic" ;;
439 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 515 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
440 esac 516 esac
441 517
442 # 4.5: build everything but qt-xmlpatterns w/o exceptions
443 # 4.6: exceptions USE flag
444 local exceptions="-exceptions"
445 case "${PV}" in
446 4.5.*)
447 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
448 ;;
449 *)
450 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
451 ;;
452 esac
453
454 # note about -reduce-relocations:
455 # That flag seems to introduce major breakage to applications,
456 # mostly to be seen as a core dump with the message "QPixmap: Must
457 # construct a QApplication before a QPaintDevice" on Solaris
458 # -- Daniel Vergien
459 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
460
461 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
462 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
463 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
464 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
465 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
466 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
467 ${exceptions}
468 -nomake examples -nomake demos"
469
470 echo "${myconf}" 518 echo "${myconf}"
471} 519}
472 520
473# @FUNCTION: build_directories 521# @FUNCTION: prepare_directories
474# @USAGE: < directories > 522# @USAGE: < directories >
523# @INTERNAL
475# @DESCRIPTION: 524# @DESCRIPTION:
476# Compiles the code in $QT4_TARGET_DIRECTORIES 525# Generates Makefiles for the given list of directories.
477build_directories() { 526prepare_directories() {
478 for x in "$@"; do 527 for x in "$@"; do
479 pushd "${S}"/${x} >/dev/null 528 pushd "${S}"/${x} >/dev/null || die
529 einfo "Running qmake in: ${x}"
480 # avoid running over the maximum argument number, bug #299810 530 # avoid running over the maximum argument number, bug #299810
481 { 531 {
482 echo "${S}"/mkspecs/common/*.conf 532 echo "${S}"/mkspecs/common/*.conf
483 find "${S}" -name '*.pr[io]' 533 find "${S}" -name '*.pr[io]'
484 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
485 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
539 popd >/dev/null || die
540 done
541}
542
543
544# @FUNCTION: build_directories
545# @USAGE: < directories >
546# @INTERNAL
547# @DESCRIPTION:
548# Compiles the code in the given list of directories.
549build_directories() {
550 for x in "$@"; do
551 pushd "${S}"/${x} >/dev/null || die
486 emake CC="$(tc-getCC)" \ 552 emake CC="$(tc-getCC)" \
487 CXX="$(tc-getCXX)" \ 553 CXX="$(tc-getCXX)" \
488 LINK="$(tc-getCXX)" || die "emake failed" 554 LINK="$(tc-getCXX)" || die "emake failed"
489 popd >/dev/null 555 popd >/dev/null || die
490 done 556 done
491} 557}
492 558
493# @FUNCTION: install_directories 559# @FUNCTION: install_directories
494# @USAGE: < directories > 560# @USAGE: < directories >
561# @INTERNAL
495# @DESCRIPTION: 562# @DESCRIPTION:
496# run emake install in the given directories, which are separated by spaces 563# Runs emake install in the given directories, which are separated by spaces.
497install_directories() { 564install_directories() {
498 for x in "$@"; do 565 for x in "$@"; do
499 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
500 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
501 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
502 done 569 done
503} 570}
504 571
505# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
506# @DESCRIPTION: 573# @DESCRIPTION:
516# @DESCRIPTION: 583# @DESCRIPTION:
517# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
518: ${QCONFIG_DEFINE:=} 585: ${QCONFIG_DEFINE:=}
519 586
520# @FUNCTION: install_qconfigs 587# @FUNCTION: install_qconfigs
588# @INTERNAL
589# @DESCRIPTION:
521# @DESCRIPTION: Install gentoo-specific mkspecs configurations 590# Install gentoo-specific mkspecs configurations.
522install_qconfigs() { 591install_qconfigs() {
523 local x 592 local x
524 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
525 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
526 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
537 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
538 fi 607 fi
539} 608}
540 609
541# @FUNCTION: generate_qconfigs 610# @FUNCTION: generate_qconfigs
542# @DESCRIPTION: Generates gentoo-specific configurations 611# @INTERNAL
612# @DESCRIPTION:
613# Generates gentoo-specific qconfig.{h,pri}.
543generate_qconfigs() { 614generate_qconfigs() {
544 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
545 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
546 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
547 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
561 632
562 # generate list of QT_CONFIG entries from the existing list 633 # generate list of QT_CONFIG entries from the existing list
563 # including qconfig_add and excluding qconfig_remove 634 # including qconfig_add and excluding qconfig_remove
564 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 635 for x in $(sed -n 's/^QT_CONFIG +=//p' \
565 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 636 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
566 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 637 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
567 done 638 done
568 639
569 # replace the existing QT_CONFIG list with qconfig_new 640 # replace the existing QT_CONFIG list with qconfig_new
570 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 641 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
571 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 642 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
595 fi 666 fi
596 fi 667 fi
597} 668}
598 669
599# @FUNCTION: qt4-build_pkg_postrm 670# @FUNCTION: qt4-build_pkg_postrm
671# @DESCRIPTION:
600# @DESCRIPTION: Generate configurations when the package is completely removed 672# Regenerate configuration when the package is completely removed.
601qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
602 generate_qconfigs 674 generate_qconfigs
603} 675}
604 676
605# @FUNCTION: qt4-build_pkg_postinst 677# @FUNCTION: qt4-build_pkg_postinst
678# @DESCRIPTION:
606# @DESCRIPTION: Generate configuration, plus throws a message about possible 679# Regenerate configuration, plus throw a message about possible
607# breakages and proposed solutions. 680# breakages and proposed solutions.
608qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
609 generate_qconfigs 682 generate_qconfigs
610} 683}
611 684
612# @FUNCTION: skip_qmake_build_patch 685# @FUNCTION: skip_qmake_build
686# @INTERNAL
613# @DESCRIPTION: 687# @DESCRIPTION:
614# Don't need to build qmake, as it's already installed from qt-core 688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
615skip_qmake_build_patch() { 689skip_qmake_build() {
616 # Don't need to build qmake, as it's already installed from qt-core
617 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
618} 691}
619 692
620# @FUNCTION: skip_project_generation_patch 693# @FUNCTION: skip_project_generation
694# @INTERNAL
621# @DESCRIPTION: 695# @DESCRIPTION:
622# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
623skip_project_generation_patch() { 697skip_project_generation() {
624 # Exit the script early by throwing in an exit before all of the .pro files are scanned
625 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
626 -i "${S}"/configure || die "Sed failed"
627} 699}
628 700
629# @FUNCTION: symlink_binaries_to_buildtree 701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
630# @DESCRIPTION: 703# @DESCRIPTION:
631# Symlink generated binaries to buildtree so they can be used during compilation 704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
632# time
633symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
634 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
635 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
636 done 708 done
637} 709}
638 710
639# @FUNCTION: fix_library_files 711# @FUNCTION: fix_library_files
712# @INTERNAL
640# @DESCRIPTION: 713# @DESCRIPTION:
641# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
642# moves the *.pc-files into the pkgconfig directory 715# moves the *.pc files into the pkgconfig directory.
643fix_library_files() { 716fix_library_files() {
717 local libfile
644 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
645 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
646 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
647 fi 721 fi
648 done 722 done
649 723
650 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
651 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
652 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
653 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
654 728
655 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
656 dodir ${QTPCDIR#${EPREFIX}} 730 dodir ${QTPCDIR#${EPREFIX}}
657 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
658 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
659 fi 732 fi
660 done 733 done
661 734
662 # Don't install an empty directory 735 # Don't install an empty directory
663 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
664} 737}
665 738
666# @FUNCTION: qt_use 739# @FUNCTION: qt_use
667# @USAGE: < flag > [ feature ] [ enableval ] 740# @USAGE: < flag > [ feature ] [ enableval ]
668# @DESCRIPTION: 741# @DESCRIPTION:
669# This will echo "${enableval}-${feature}" if <flag> is enabled, or 742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
670# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
671# will be used for that. If [enableval] is not specified, it omits the 744# will be used for that. If [enableval] is not specified, it omits the
672# assignment-part 745# "-${enableval}" part.
673qt_use() { 746qt_use() {
674 local flag=$1 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
675 local feature=$1
676 local enableval=
677
678 [[ -n $2 ]] && feature=$2
679 [[ -n $3 ]] && enableval=-$3
680
681 if use ${flag}; then
682 echo "${enableval}-${feature}"
683 else
684 echo "-no-${feature}"
685 fi
686} 748}
687 749
688# @FUNCTION: qt_mkspecs_dir 750# @FUNCTION: qt_mkspecs_dir
689# @RETURN: the specs-directory w/o path 751# @RETURN: the specs-directory w/o path
690# @DESCRIPTION: 752# @DESCRIPTION:
691# Allows us to define which mkspecs dir we want to use. 753# Allows us to define which mkspecs dir we want to use.
692qt_mkspecs_dir() { 754qt_mkspecs_dir() {
693 # Allows us to define which mkspecs dir we want to use.
694 local spec 755 local spec=
695
696 case ${CHOST} in 756 case ${CHOST} in
697 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
698 spec=freebsd ;; 758 spec=freebsd ;;
699 *-openbsd*) 759 *-openbsd*)
700 spec=openbsd ;; 760 spec=openbsd ;;
712 *-solaris*) 772 *-solaris*)
713 spec=solaris ;; 773 spec=solaris ;;
714 *-linux-*|*-linux) 774 *-linux-*|*-linux)
715 spec=linux ;; 775 spec=linux ;;
716 *) 776 *)
717 die "Unknown CHOST, no platform choosen." 777 die "Unknown CHOST, no platform chosen"
718 esac 778 esac
719 779
720 CXX=$(tc-getCXX) 780 CXX=$(tc-getCXX)
721 if [[ ${CXX} == *g++* ]]; then 781 if [[ ${CXX} == *g++* ]]; then
722 spec+=-g++ 782 spec+=-g++
723 elif [[ ${CXX} == *icpc* ]]; then 783 elif [[ ${CXX} == *icpc* ]]; then
724 spec+=-icc 784 spec+=-icc
725 else 785 else
726 die "Unknown compiler ${CXX}." 786 die "Unknown compiler '${CXX}'"
727 fi
728 if [[ -n ${LIBDIR/lib} ]]; then
729 spec+=-${LIBDIR/lib}
730 fi 787 fi
731 788
732 # Add -64 for 64bit profiles 789 # Add -64 for 64bit profiles
733 if use x64-freebsd || 790 if use x64-freebsd ||
734 use amd64-linux || 791 use amd64-linux ||
740 fi 797 fi
741 798
742 echo "${spec}" 799 echo "${spec}"
743} 800}
744 801
802# @FUNCTION: qt_assistant_cleanup
803# @INTERNAL
804# @DESCRIPTION:
805# Tries to clean up tools.pro for qt-assistant ebuilds.
806# Meant to be called in src_prepare().
807# Since Qt 4.7.4 this function is a no-op.
808qt_assistant_cleanup() {
809 # apply patching to qt-assistant ebuilds only
810 [[ ${PN} != "qt-assistant" ]] && return
811
812 # no longer needed for 4.7.4 and later
813 version_is_at_least "4.7.4" && return
814
815 # different versions (and branches...) may need different handling,
816 # add a case if you need special handling
817 case "${MY_PV_EXTRA}" in
818 *kde-qt*)
819 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
820 -e "/mac/,/^embedded.*makeqpf$/d" \
821 -i tools/tools.pro || die "patching tools.pro failed"
822 ;;
823 *)
824 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
825 -e "/mac/,/^embedded.*makeqpf$/d" \
826 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
827 -i tools/tools.pro || die "patching tools.pro failed"
828 ;;
829 esac
830}
831
832# @FUNCTION: qt_nolibx11
833# @INTERNAL
834# @DESCRIPTION:
835# Ignore X11 tests for packages that don't need X libraries installed.
836qt_nolibx11() {
837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
838 die "x11 check sed failed"
839}
840
745EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.75  
changed lines
  Added in v.1.118

  ViewVC Help
Powered by ViewVC 1.1.20